<!DOCTYPE html>
<html lang="en">
<head>
    {% block head %}
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">

    <title>{% block title %}{% endblock %} Pipeline Visualization API </title>
    
    <link rel="canonical" href="https://getbootstrap.com/docs/5.0/examples/sidebars/">
    <link rel="stylesheet" href="./statics/css/style.css">
    <link rel="stylesheet" href="./statics/css/sidebars.css">
    <link rel="stylesheet" href="./statics/css/toggle.css">
    <link rel="stylesheet" href="./statics/css/bootstrap.min.css", rel="stylesheet">
    
    <link rel="stylesheet" href="https://cdn.datatables.net/1.13.4/css/jquery.dataTables.min.css">

    <script src="https://cdn.jsdelivr.net/npm/xml-digester@0.0.5/lib/xml-digester.js"></script>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.3/jquery.min.js"></script>
    <script src="https://cdn.datatables.net/1.13.4/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/rowgroup/1.4.0/js/dataTables.rowGroup.min.js"></script>

    <script src="https://d3js.org/d3.v7.min.js"></script>

    <script src="./statics/js/bootstrap.bundle.min.js"></script>
    <script src="./statics/js/sidebars.js"></script>    
    <script src="./statics/js/tree.js"></script>
   

    <style>
        .bd-placeholder-img {
        font-size: 1.125rem;
        text-anchor: middle;
        -webkit-user-select: none;
        -moz-user-select: none;
        user-select: none;
        }

        @media (min-width: 768px) {
        .bd-placeholder-img-lg {
            font-size: 3.5rem;
        }
        }
        ul {
            display: flex;
            flex-direction: column;
            }

        li {
            margin:0 0 10px 0;   
            }
    </style>

     {% endblock %}
</head>
<body>
    
    <div id="app" >

            <div class="sidebar bg-dark">
                {% block workflow %}
                    <form id="workflowForm" method="POST" action="{{ url_for('select_workflow') }}">
                        <label for="folders">Workflow:</label>
                        <select oninput="workflowSelected()" name="folder" id="folders">
                            <option value="DGINN" {{'selected' if folder_name=='DGINN' }}>DGINN</option>
                            <option value="RNAseq" {{'selected' if folder_name=='RNAseq' }}>RNAseq</option>
                            <option value="DNAseq" {{'selected' if folder_name=='DNAseq' }}>DNAseq</option>
                        </select>
                        <!--input type="submit" value="Select"-->

                    </form>
                    
                    {% block DGINN %} 
                        
                    {% endblock %}                    
                {% endblock %}
            </div>
             
                {% block result %} 
                
                {% endblock %}



    </div>
</body>

<script>

    // select the button and output element in the HTML

    const outputElement = document.getElementById('result');
    var intervallPolling;

    // function for stop the execution
    function stopExecution(){
        fetch("./stop")
        .then((response) => response.text())
        .then(log =>{
            clearInterval(intervallPolling)
      })
     }

    // function for update the instance pipeline
    function updateInstances(){
        fetch("./get_instances")
        .then((response) => response.json())
        .then(data => {
            $("#instances-select").html("");
            data.forEach(instance => {
                $("#instances-select").append(`<option value="${instance}">${instance}</option>`)
            });
            // Set the value of the select element to the latest instance in the data array
            const latestInstance = data[data.length - 1];
            $("#instances-select").val(latestInstance);
            resultChanged($("#instances-select").val())
        })
    }

    // function for desplay the results by dataTable
    
    function resultChanged(instance){
        
        fetch(`./get_results/${instance}`)
        .then((response) => response.json())
        .then(data => {
            var rows = data.map(item => [item,item.path,item.classify]);

            var datatable = $("#myTable").DataTable()
                datatable.clear();
                datatable.rows.add(rows)
                datatable.draw();
        })
    }

    $(document).ready(function() {
        updateInstances();
       // let table = new DataTable('#myTable');
        $("#myTable").DataTable({
            scrollY: true,
            order:[[2,'asc']],
            rowGroup: {
                dataSrc: 2
            },
            "autoWidth": false,
            columnDefs: [
            {
                render: function (data, type, row) {
                    return `<span title="${data.path}">${data.name}</span>`;
                },
                "width": "700px",
                targets: 0,
            },
            {
                render: function (data, type, row) {
                    let download = `<a href="./download?file=${encodeURI(data)}" target="_blank"><button type="button" class="btn btn-secondary">
                        <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-download" viewBox="0 0 16 16">
                            <path d="M.5 9.9a.5.5 0 0 1 .5.5v2.5a1 1 0 0 0 1 1h12a1 1 0 0 0 1-1v-2.5a.5.5 0 0 1 1 0v2.5a2 2 0 0 1-2 2H2a2 2 0 0 1-2-2v-2.5a.5.5 0 0 1 .5-.5z"/>
                            <path d="M7.646 11.854a.5.5 0 0 0 .708 0l3-3a.5.5 0 0 0-.708-.708L8.5 10.293V1.5a.5.5 0 0 0-1 0v8.793L5.354 8.146a.5.5 0 1 0-.708.708l3 3z"/>
                        </svg></button></a>`
                    let viewTree = ``
                    if (data.endsWith("phylip_phyml_tree.txt") || data.endsWith(".nhx")) {
                        viewTree = ` <a href="./view?file=${encodeURI(data)}" target="_blank"><button type="button" class="btn btn-secondary">
                            <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-eye-fill" viewBox="0 0 16 16">
                                <path d="M10.5 8a2.5 2.5 0 1 1-5 0 2.5 2.5 0 0 1 5 0z"/>
                                <path d="M0 8s3-5.5 8-5.5S16 8 16 8s-3 5.5-8 5.5S0 8 0 8zm8 3.5a3.5 3.5 0 1 0 0-7 3.5 3.5 0 0 0 0 7z"/>
                            </svg>    
                        </button></a>`
                    }
                    return download+viewTree;
                },
                targets: 1,
            }
        ]
        })
    });
    

    function rerunSnakeMake(){
        intervallPolling = setInterval(poll,1000);
        fetch("./rerun")
            .then((response) => response.text())
            .then(log =>{
                
                clearInterval(intervallPolling)
                poll();
                clearInterval(intervallPolling);
                displayTree();
      })

     }

    function workflowSelected(){
        $("#workflowForm").submit();
    }

   
    // The js polling() function can generate log messages over time.
    function poll() {
        fetch("./log")
            .then((response) => response.text())
            .then(log => {
                if (log && log!=""){
                    document.getElementById("output").innerHTML = log;
                }
                
            });

        fetch("./progression")
            .then((response) => response.text())
            .then(progression => {
                if (progression && progression!=""){
                    document.getElementById("progressbar").style.setProperty("--progress",progression);
                }
                
            });
    }

    function uploadFormDGINN(event){
        event.preventDefault();
        var formData = new FormData();

        formData.append("fasta_file",$("#fasta_file")[0].files[0]);
        formData.append("tree_file",$("#tree_file")[0].files[0]);
        formData.append("sptree_file",$("#sptree_file")[0].files[0]);
        formData.append("duplication",$("#duplication").is(":checked")); // true and false request for key=>"duplication" and value=>$("#duplication").is(":checked")
        formData.append("recombination",$("#recombination").is(":checked"));
        formData.append("positiveSelection",$("#positiveSelection").is(":checked"));
        formData.append("prank",$("#prank").is(":checked"));
        formData.append("macse",$("#macse").is(":checked"));
        formData.append("nt",$("#nt").is(":checked"));
        formData.append("api-key",$("#api-key").val());

        intervallPolling = setInterval(poll,1000);
        document.getElementById("output").innerHTML = ""; 
        $('#progressbar').removeClass('hidden')

        $.ajax({
            type: "POST",
            enctype: 'multipart/form-data',
            url: "/upload_dginn",
            data: formData,
            processData: false,
            timeout: 3600000,
            contentType: false,
            cache: false,

            success: function (data) {
                poll();

                clearInterval(intervallPolling);
                updateInstances();
                //$('#progressbar').addClass('hidden')

            },
            error: function (e) {
                poll();
                clearInterval(intervallPolling);
                updateInstances();
                $('#progressbar').addClass('hidden')
            }
        });
    }



    
</script>

</html>